package com.sojson.core.freemarker.function;

import java.util.List;

import com.sojson.common.utils.LoggerUtils;
import com.sojson.core.shiro.cache.VCache;

import freemarker.template.SimpleScalar;
import freemarker.template.TemplateMethodModelEx;
import freemarker.template.TemplateModelException;

/**
 * 
 * 开发公司：SOJSON在线工具 <p>
 * 版权所有：© www.sojson.com<p>
 * 博客地址：http://www.sojson.com/blog/  <p>
 * <p>
 * 
 * 从缓存获取值
 * 
 * <p>
 * 
 * 区分　责任人　日期　　　　说明<br/>
 * 创建　周柏成　2017年2月27日 　<br/>
 *
 * @author zhou-baicheng
 * @email  so@sojson.com
 * @version 1.0,2017年2月27日 <br/>
 * 
 */
@SuppressWarnings({"unchecked","rawtypes"})
public class GetCache implements TemplateMethodModelEx{
	
		/**
		 * @使用  args[0]:缓存key
		 */
		@Override
		public Object exec(List args) throws TemplateModelException {
			SimpleScalar key  = (SimpleScalar)  args.get(0);
			
			if(null  ==  key){
				LoggerUtils.fmtDebug(getClass(), "从缓存获取值时，发现KEY为空" );
				return "";
			}
			return VCache.get(key.getAsString());
		}
	}