package com.sojson.core.freemarker.function;

import java.util.List;

import net.sf.json.JSONObject;

import com.sojson.common.utils.LoggerUtils;
import com.sojson.common.utils.StringUtils;

import freemarker.template.SimpleScalar;
import freemarker.template.TemplateMethodModelEx;
import freemarker.template.TemplateModelException;

/**
 * 
 * 开发公司：SOJSON在线工具 <p>
 * 版权所有：© www.sojson.com<p>
 * 博客地址：http://www.sojson.com/blog/  <p>
 * <p>
 * 
 *  从一个JSON中得到对应的值
 * 
 * <p>
 * 
 * 区分　责任人　日期　　　　说明<br/>
 * 创建　周柏成　2017年2月27日 　<br/>
 *
 * @author zhou-baicheng
 * @email  so@sojson.com
 * @version 1.0,2017年2月27日 <br/>
 * 
 */
public class Option implements TemplateMethodModelEx{
		/**
		 * @使用规则
		 *  args[0] : key				 如 : 1
		 *  args[1] : JSON Data，如：'{"1":"男","0":"女","default":"未知"}'
		 *  使用 Option('1','{"1":"男","0":"女","default":"未知"}') 得到的是男
		 */
		@Override
		public Object exec(@SuppressWarnings("rawtypes") List args) throws TemplateModelException {
			if(args.size() !=2){
				LoggerUtils.fmtDebug(getClass(), "参数个数不对，得到的个数为：%s",args.size() );
				return "";
			}
			SimpleScalar type  = (SimpleScalar) args.get(0);
			SimpleScalar json  = (SimpleScalar)args.get(1);
			if(StringUtils.isBlank(type,json)){
				LoggerUtils.fmtDebug(getClass(), "有为空的参数！" );
				return "";
			}
			String jsonStr = json.getAsString();
			String typeStr =type.getAsString();
			JSONObject so = JSONObject.fromObject(jsonStr);
			String defau  = so.optString("default");
			String result = so.optString(typeStr)==null?defau:so.optString(typeStr);
			return result ;
		
		}
	}